import Data.Char
  
digitsComp :: [Char] -> [Char]
digitsComp xs  =  [ x | x <- xs, isDigit x ]

digitsRec :: [Char] -> [Char]
digitsRec []                  =  []
digitsRec (x:xs) | isDigit x  =  x : digitsRec xs
                 | otherwise  =  digitsRec xs

digitsFilter :: [Char] -> [Char]
digitsFilter xs  =  filter isDigit xs

prop_digits :: [Char] -> Bool
prop_digits xs  =  digitsComp xs == digitsRec xs && digitsRec xs == digitsFilter xs
